<template>
    <div>
        <div class="filters-container">

            <el-input placeholder="用户名" size="small" v-model="filter1" clearable class="filter-item"></el-input>

            <el-button @click="searchData" type="primary" size="small" icon="el-icon-search" class="filter-item">搜索
            </el-button>
            <el-button @click="$router.push('/contactRecord')" type="primary" size="small" icon="el-icon-edit" class="filter-item">添加
            </el-button>
            <el-dropdown trigger="click" size="medium" class="table-column-filter">
                <span>
                    筛选数据
                    <i class="el-icon-arrow-down el-icon--right"></i>
                </span>
                <el-dropdown-menu slot="dropdown" class="table-column-filter-wrapper">
                    <el-checkbox v-for="item in tableColumns" :key="item.value" v-model="item.show">{{item.label}}
                    </el-checkbox>
                </el-dropdown-menu>
            </el-dropdown>
        </div>
        <el-table :data="tableData" :height="tableHeight" row-key="id" ref="table">
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50">
            </el-table-column>
            <el-table-column type="index" min-width="50" align="center">
            </el-table-column>
            <el-table-column v-if="isColumnShow('userId')" prop="userId" label="用户ID" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('userInfo.nickname')" prop="userInfo.nickname" label="用户" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('houseId')" prop="houseId" label="房源" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('houseInfo.title')" prop="houseInfo.title" label="房源标题" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('housekeeper')" prop="housekeeper" label="管家ID" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('keeper.keepName')" prop="keeper.keepName" label="管家" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('showFlag')" prop="showFlag" label="用户显示" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('createTime')" prop="createTime" :formatter="DateTimeFormatter" label="创建时间" min-width="140">
            </el-table-column>
            <el-table-column v-if="isColumnShow('updateTime')" prop="updateTime" :formatter="DateTimeFormatter" label="更新时间" min-width="140">
            </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="scope">
                    <el-button @click="editRow(scope.row)" type="primary" size="mini" plain>编辑</el-button>
                    <el-button @click="deleteRow(scope.row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <el-pagination background @size-change="pageSizeChange" @current-change="currentPageChange" :current-page="currentPage" :page-sizes="[10, 20, 30, 40, 50]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="totalNumber">
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex'
import { format } from 'date-fns'
import zh from 'date-fns/locale/zh_cn'

export default {
    created() {
        this.getData();
    },
    data() {
        return {
            totalNumber: 0,
            totalPage: 10,
            currentPage: 1,
            pageSize: 20,
            tableData: [],
            filter1: '',
            filter2: '',
            tableColumns: [
                {
                    label: '用户ID',
                    value: 'userId',
                    show: true
                },
                {
                    label: '用户',
                    value: 'userInfo.nickname',
                    show: true
                },
                {
                    label: '房源',
                    value: 'houseId',
                    show: true
                },
                {
                    label: '房源标题',
                    value: 'houseInfo.title',
                    show: true
                },
                {
                    label: '管家ID',
                    value: 'housekeeper',
                    show: true
                },
                {
                    label: '管家',
                    value: 'keeper.keepName',
                    show: true
                },
                {
                    label: '用户显示',
                    value: 'showFlag',
                    show: true
                },
                {
                    label: '创建时间',
                    value: 'createTime',
                    show: true
                },
                {
                    label: '更新时间',
                    value: 'updateTime',
                    show: true
                },
            ],
            multipleMode: false
        }
    },
    computed: {
        ...mapState(['tableHeight']),
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        pageSizeChange(size) {
            this.currentPage = 1;
            this.pageSize = size;
            this.getData();
        },
        currentPageChange(page) {
            this.currentPage = page;
            this.getData();
        },
        getData() {
            this.$http.get({
                url: '/contactRecord/page',
                data: {
                    currentPage: this.currentPage,
                    pageNumber: this.pageSize,
                    searchKey: this.filter1,
                }
            }).then(res => {
                if (res.success) {
                    this.totalNumber = res.data.page.totalNumber;
                    this.tableData = res.data.pp;
                }
            })
        },
        isColumnShow(column) {
            var row = this.tableColumns.find(i => i.value === column);
            return row ? row.show : false;
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        editRow(row) {
            this.$router.push({
                path: '/contactRecord',
                query: {
                    id: row.id
                }
            })
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        DateTimeFormatter(row, column, cellValue) {
            if (cellValue) {
                return format(cellValue, 'YYYY/MM/DD HH:mm', { locale: zh })
            }

        },
        searchData() {
            this.currentPage = 1;
            this.getData();
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
                return this.$http.post({
                    url: '/contactRecord/del',
                    data: { id: row.id }
                })
            }).then(() => {
                this.$message.success('删除成功');
                this.getData();
            }).catch(action => {
                if (action === 'cancel') {
                    this.$message.info('删除取消');
                } else {
                    this.$message.error('删除失败');
                }
            })
        },
    }
}
</script>
<style lang="less" scoped>
</style>
